/* 	appVOC - Application of voice call service
 *
 *	Authors: JIANG Dan <dan.jiang@orange-ftgroup.com> 
 *	
 *	This software and associated documentation files (the "Software") 
 *	are copyright (C) 2005 LiPS Linux Phone Standards Forum [FranceTelecom] 
 *	All Rights Reserved. 
 *
 *	A copyright license is hereby granted for redistribution and use of 
 *	the Software in source and binary forms, with or without modification, 
 *	provided that the following conditions are met: 
 *	- Redistributions of source code must retain the above copyright notice, 
 *	this copyright license and the following disclaimer. 
 *- Redistributions in binary form must reproduce the above copyright 
 *	notice, this copyright license and the following disclaimer in the 
 *	documentation and/or other materials provided with the distribution. 
 *	- Neither the name of LiPS  nor the names of its Members may be used 
 *	to endorse or promote products derived from the Software without 
 *	specific prior written permission. 
 *
 *	A patent license for any Necessary Claims owned by Members of LiPS Forum 
 *	to make, have made, use, import, offer to sell, lease and sell or otherwise 
 *	distribute any implementation compliant with the any specification adopted 
 *	by the LiPS Forumcan be obtained from the respective Members on reasonable 
 *	and non-discriminatory terms and conditions and under reciprocity, as 
 *	regulated in more detail in the Internal Policy of the LiPS Forum. 
 *
 *	THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER, ITS MEMBERS AND CONTRIBUTORS 
 *	"AS IS", AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, 
 *	THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE 
 *	AND NON-INFRINGEMENT ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER, 
 *	ITS MEMBERS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
 *	SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, 
 *	PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; 
 *	OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, 
 *	WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) 
 *	ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE 
 *	POSSIBILITY OF SUCH DAMAGE. 
 */

#define DEBUG

#include <glib.h>
#include <string.h>
#include <stdio.h>
#include <stdlib.h>

#include "callbacks.h"
#include <voctype.h>

#include "interface.h"
#include "icmc.h"


void
voc_cb_dial (voc_sid_t sid, voc_evt_t *evt)
{
  printf ("cb_dial called!\n");
  cb_outgoing_connected (evt->evt_data);
}

void
voc_cb_hungup (voc_sid_t sid, voc_evt_t *evt)
{
  printf ("cb_hungup called!\n");

  cb_hungup (evt->evt_data);
}

void
voc_cb_hungup_all (voc_sid_t sid, voc_evt_t *evt)
{
  printf ("cb_hungup call called!\n");

  cb_hungup_all (evt->evt_data);
}


void
voc_cb_hungup_active (voc_sid_t sid, voc_evt_t *evt)
{
  printf ("cb_hungup_active called!\n");

  cb_hungup_active (evt->evt_data);
}

void
voc_cb_replace_hold (voc_sid_t sid, voc_evt_t *evt)
{
  printf ("\n\n\n\n\n\n\n\ncb_replace_hold called!\n\n\n\n\n\n\n");

  cb_replace_hold (evt->evt_data);
}


void
voc_cb_hungup_held (voc_sid_t sid, voc_evt_t *evt)
{
  printf ("cb_hungup_held called!\n");

  cb_hungup (evt->evt_data);
}

void
voc_cb_accept (voc_sid_t sid, voc_evt_t *evt)
{
  printf ("cb_accept called!\n");
  g_print ("cid=%d", evt->evt_data);
  cb_accept (evt->evt_data);

}

void
voc_cb_onhold (voc_sid_t sid, voc_evt_t *evt)
{
  printf ("cb_onhold called!\n");
  g_print ("cid=%d", evt->evt_data);
  cb_hold (evt->evt_data);
}


void
voc_cb_onhold_dial (voc_sid_t sid, voc_evt_t *evt)
{
  printf ("==================cb_onhold dial called!\n");
  g_print ("step 1: onhold called!\n");
  cb_hold (0);

  g_print ("step 2: cb_dial called!\n");
  cb_outgoing_connected (evt->evt_data);

}

void
voc_cb_conference (voc_sid_t sid, voc_evt_t *evt)
{
  printf ("cb_onhold called!\n");
  g_print ("cid=%d", evt->evt_data);
  cb_conference (evt->evt_data);
}



void
voc_cb_exit_conference (voc_sid_t sid, voc_evt_t *evt)
{
  printf ("cb_onhold called!\n");
  g_print ("cid=%d", evt->evt_data);
  cb_exitconf (evt->evt_data);
}

void
voc_cb_incoming (voc_sid_t sid, voc_evt_t *evt)
{
  printf ("\n\n APP VOC cb_incoming called!\n");
  char *cname = "Unknown";

  if (evt->user_data)
  {
    g_print ("in %s, the number is: %s", __FUNCTION__, (char *) evt->user_data);
    cname = (char *) evt->user_data;
  }
  else
  {
    g_print ("in %s, the number is not valid", __FUNCTION__);
  }
  UInt32 cid;

  cid = evt->evt_data;

  printf ("\n\n APP VOC 1\n");
  extern gboolean iswifi_flag;
  extern gboolean haswifi_flag;

  if (sid == 0)
    iswifi_flag = FALSE;
  else
  {
    iswifi_flag = TRUE;
    haswifi_flag = TRUE;
  }
  create_icmcdialog (cid, cname);
}

void
voc_cb_remote_status (voc_sid_t sid, voc_evt_t *evt)
{
  printf ("cb_remote status is called!\n");

  cb_hungup (evt->evt_data);

}

void
voc_cb_mute (voc_sid_t sid, voc_evt_t *evt)
{
  printf ("cb_mute called!\n");
}


/* 
vi:ts=2:nowrap:ai:expandtab
*/

