/* 	appVOC - Application of voice call service
 *
 *	Authors: JIANG Dan <dan.jiang@orange-ftgroup.com> 
 *	
 *	This software and associated documentation files (the "Software") 
 *	are copyright (C) 2005 LiPS Linux Phone Standards Forum [FranceTelecom] 
 *	All Rights Reserved. 
 *
 *	A copyright license is hereby granted for redistribution and use of 
 *	the Software in source and binary forms, with or without modification, 
 *	provided that the following conditions are met: 
 *	- Redistributions of source code must retain the above copyright notice, 
 *	this copyright license and the following disclaimer. 
 *- Redistributions in binary form must reproduce the above copyright 
 *	notice, this copyright license and the following disclaimer in the 
 *	documentation and/or other materials provided with the distribution. 
 *	- Neither the name of LiPS  nor the names of its Members may be used 
 *	to endorse or promote products derived from the Software without 
 *	specific prior written permission. 
 *
 *	A patent license for any Necessary Claims owned by Members of LiPS Forum 
 *	to make, have made, use, import, offer to sell, lease and sell or otherwise 
 *	distribute any implementation compliant with the any specification adopted 
 *	by the LiPS Forumcan be obtained from the respective Members on reasonable 
 *	and non-discriminatory terms and conditions and under reciprocity, as 
 *	regulated in more detail in the Internal Policy of the LiPS Forum. 
 *
 *	THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER, ITS MEMBERS AND CONTRIBUTORS 
 *	"AS IS", AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, 
 *	THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE 
 *	AND NON-INFRINGEMENT ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER, 
 *	ITS MEMBERS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
 *	SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, 
 *	PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; 
 *	OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, 
 *	WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) 
 *	ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE 
 *	POSSIBILITY OF SUCH DAMAGE. 
 */


#include "linestate.h"
#include "inputwindow.h"
#include "callingwindow.h"
#include "connectedwindow.h"
#include "icmc.h"
#include "volumebar.h"
#include <voc.h>
static GdkColor list_bg = { 0, 57015, 61602, 62879 };
static GdkColor black = { 0, 0, 0, 0 };
static GdkColor col2 = { 0, 0xffff, 0x7fff, 0 };
static GtkStyle *style1 = NULL;
enum
{
  I_ACTIVE = 0,
  I_HOLD = 1,
  I_WIFI = 2,
  I_CONFERENCE = 3,
  I_WIFIHOLD,
  I_NUM_SUF,
  I_NUM
};
static struct
{
  GtkWidget *window;
  GtkWidget *layoutfix;
  GtkWidget *list;
  GdkPixbuf *s_image_buf[I_NUM];
  GtkWidget *state_image;
  GtkWidget *identity_image;
  GtkWidget *con_label, *num_label, *time_label, *inputlabel;
  gboolean have_softkeys;
  gint num_softkeys;
  GtkActionGroup *action_group;
  GtkUIManager *ui_manager;
  GtkWidget *menu_left;
  GtkWidget *menu_right;
} self;
static void select_changed (GtkCList *clist, gint row, gint column,
                            GdkEventButton *event, gpointer user_data);
void flush_label ();
void update_list ();
static void
newcall ()
{
  show_inputwindow ("", NULL, NULL);
}
static void
hold ()
{
  if (g_array_index (call_array, call_desc, displaycallnum).state != HOLD)
  {
//    if (!voc_gsm_onhold
    if (!voc_onhold		
        (0, g_array_index (call_array, call_desc, displaycallnum).cid))
    {
      voc_call_evt_register (0, g_array_index (call_array, call_desc, displaycallnum).cid, VOC_EVT_CALL_STATUS, NULL, voc_cb_onhold, NULL);     //cb1 is used to change the UI, etc.
    }
  }
}

static void
active ()
{
//  if (!voc_gsm_onhold
  if (!voc_onhold
      (0, g_array_index (call_array, call_desc, displaycallnum).cid))
  {
    voc_call_evt_register (0, g_array_index (call_array, call_desc, displaycallnum).cid, VOC_EVT_CALL_STATUS, NULL, voc_cb_onhold, NULL);       //cb1 is used to change the UI, etc.
  }

}

static void
swap ()
{
  if (ACTIVECALLINDEX != -1)
  {
    g_print ("##################SWAP command send out!with cid=%d",
             g_array_index (call_array, call_desc, ACTIVECALLINDEX).cid);
    //if (!voc_gsm_onhold
    if (!voc_onhold		
        (0, g_array_index (call_array, call_desc, ACTIVECALLINDEX).cid))
    {
      voc_call_evt_register (0, g_array_index (call_array, call_desc, ACTIVECALLINDEX).cid, VOC_EVT_CALL_STATUS, NULL, voc_cb_onhold, NULL);    //cb1 is used to change the UI, etc.
    }

    if (haswifi_flag)
    {
      if (g_array_index (call_array, call_desc, ACTIVECALLINDEX).cid == 60001)
      {
//        voc_wifi_onhold (1, 60001);
        voc_onhold (1, 60001);
      	}
      else
      {
 //       voc_wifi_unhold (1, 60001);
        voc_unhold (1, 60001);
      	}
    }
  }
}

static void
hangup ()
{
  if (BUSYLINECOUNT == 1)
  {
    if (g_array_index (call_array, call_desc, displaycallnum).state == ACTIVE)
    {
      g_print ("enter voc_cb_hungup 1\n");
      /*busyline=1, active*/
      //if (!voc_gsm_hungup_all
      if (!voc_hungup_all	  	
          (0, g_array_index (call_array, call_desc, displaycallnum).cid))
      {
        voc_call_evt_register (0, g_array_index (call_array, call_desc, displaycallnum).cid, VOC_EVT_CALL_STATUS, NULL, voc_cb_hungup_all, NULL);       //cb1 is used to change the UI, etc.
      }
    }
    else
    {                           //not active, busyline=1
      g_print ("enter voc_cb_hungup 2\n");
     // if (!voc_gsm_hungup_held
      if (!voc_hungup_held	  	
          (0, g_array_index (call_array, call_desc, displaycallnum).cid))
      {
        voc_call_evt_register (0, g_array_index (call_array, call_desc, displaycallnum).cid, VOC_EVT_CALL_STATUS, NULL, voc_cb_hungup, NULL);   //cb1 is used to change the UI, etc.
      }
    }
  }
  else
  {                             //busyline!=1
    g_print ("enter voc_cb_hungup_active 3\n");
    if (haswifi_flag)
    {
     // if (!voc_gsm_hungup_active
      if (!voc_hungup_active	  	
          (0, g_array_index (call_array, call_desc, ACTIVECALLINDEX).cid))
      {
        voc_call_evt_register (0, g_array_index (call_array, call_desc, ACTIVECALLINDEX).cid, VOC_EVT_CALL_STATUS, NULL, voc_cb_hungup, NULL);  //cb1 is used to change the UI, etc. 
      }
    }
    else
    {
//      if (!voc_gsm_hungup_active
      if (!voc_hungup_active	  	
          (0, g_array_index (call_array, call_desc, ACTIVECALLINDEX).cid))
      {
        voc_call_evt_register (0, g_array_index (call_array, call_desc, ACTIVECALLINDEX).cid, VOC_EVT_CALL_STATUS, NULL, voc_cb_hungup_active, NULL);   //cb1 is used to change the UI, etc.
      }

    }                           //end else haswifi_flag   
  }                             //end else busyline==1
}
static void
hangupall ()
{
//  if (!voc_gsm_hungup_all
  if (!voc_hungup_all  	
      (0, g_array_index (call_array, call_desc, displaycallnum).cid))
  {
    voc_call_evt_register (0, g_array_index (call_array, call_desc, displaycallnum).cid, VOC_EVT_CALL_STATUS, NULL, voc_cb_hungup_all, NULL);   //cb1 is used to change the UI, etc.
  }

}



static void
conference ()
{
  if (ACTIVECALLINDEX != -1)
  {
    g_print ("##################Conference command send out!with cid=%d",
             g_array_index (call_array, call_desc, displaycallnum).cid);

//    if (!voc_gsm_conference
    if (!voc_conference		
        (0, g_array_index (call_array, call_desc, displaycallnum).cid))
    {
      voc_call_evt_register (0, g_array_index (call_array, call_desc, displaycallnum).cid, VOC_EVT_CALL_STATUS, NULL, voc_cb_conference, NULL); //cb1 is used to change the UI, etc.
    }
  }
}


static void
exitconf ()
{
  if (ACTIVECALLINDEX != -1)
  {
    g_print ("##################Conference command send out!with cid=%d",
             g_array_index (call_array, call_desc, displaycallnum).cid);
//    if (!voc_gsm_exit_conference
    if (!voc_exit_conference
        (0, g_array_index (call_array, call_desc, displaycallnum).cid))
    {
      voc_call_evt_register (0, g_array_index (call_array, call_desc, displaycallnum).cid, VOC_EVT_CALL_STATUS, NULL, voc_cb_exit_conference, NULL);    //cb1 is used to change the UI, etc.
    }
  }
}


static void
mute ()
{
  ismute = !ismute;
  g_print ("The mute paramaters equals to: %d\n", ismute);
  UInt32 umute;

  if (ismute)
    umute = 1;
  else
    umute = 0;
  g_print ("The mute paramaters equals to: %d\n", umute);

//  voc_gsm_mute (0, umute);
  voc_mute (0, umute);
  update_display ();
  //volume_set_to_min(ismute);
}


//jd
static void
terminate ()
{
  static int i = 0;

  g_print ("??????????????????enter terminate funciton for time %d\n", i);
  if (isfirst_flag)
  {
    isfirst_flag = FALSE;
    g_print ("??????????????????send out terminate command for time %d\n", i++);
//    voc_wifi_hungup (1, 60001);
    voc_hungup (1, 60001);	
    haswifi_flag = FALSE;
    //voc_call_evt_register (1, g_array_index(call_array,call_desc,displaycallnum).cid, VOC_EVT_CALL_STATUS, NULL, voc_cb_hungup_all, NULL);//cb1 is used to change the UI, etc.
    voc_call_evt_register (1, 60008, VOC_EVT_CALL_STATUS, NULL, voc_cb_hungup, NULL);   //cb1 is used to change the UI, etc.
  }
}

static void
wunhold ()
{
  g_print ("??????????????????enter whold funciton !!!!!!!!!!\n");

//  voc_wifi_unhold (1, 60001);
  voc_unhold (1, 60001);
  voc_call_evt_register (1, 60001, VOC_EVT_CALL_STATUS, NULL, voc_cb_onhold, NULL);     //cb1 is used to change the UI, etc.
}



static void
whold ()
{

  g_print ("the display = %d, the real is 60001\n",
           g_array_index (call_array, call_desc, displaycallnum).cid);
  if (g_array_index (call_array, call_desc, displaycallnum).state != HOLD)
  {
//    if (!voc_wifi_onhold (1, 60001))
    if (!voc_onhold (1, 60001))
    {
      voc_call_evt_register (1, 60001, VOC_EVT_CALL_STATUS, NULL, voc_cb_onhold, NULL); //cb1 is used to change the UI, etc.
    }
  }
}


static const gchar *ui_description = " \
    <ui>\
      <popup  action=\"PopupLeft\">\
        <menuitem name=\"newcall\" action=\"newcall\"/>\
        <menuitem name=\"swap\" action=\"swap\"/>\
        <menuitem name=\"conference\" action=\"conference\"/>\
        <menuitem name=\"exit_conference\" action=\"exitconf\"/>\
        <menuitem name=\"addtoconference\" action=\"addtoconference\"/>\
        <menuitem name=\"hold\" action=\"hold\"/>\
        <menuitem name=\"active\" action=\"active\"/>\
        <menuitem name=\"mute\" action=\"mute\"/>\
        <menuitem name=\"unmute\" action=\"unmute\"/>\
        <menuitem name=\"hangup\" action=\"hangup\"/>\
        <menuitem name=\"hangupall\" action=\"hangupall\"/>\
        <menuitem name=\"terminate\" action=\"terminate\"/>\
        <menuitem name=\"whold\" action=\"whold\"/>\
        <menuitem name=\"wunhold\" action=\"wunhold\"/>\
      </popup>\
    </ui>\
    ";
static const GtkActionEntry action_entries[] = {
  {"newcall", NULL, "_Newcall", "", "newcall", G_CALLBACK (newcall)},
  {"hold", NULL, "_Hold", "", "hold", G_CALLBACK (hold)},
  {"active", NULL, "_Active", "", "active", G_CALLBACK (active)},
  {"hangup", NULL, "_Hangup Active                  ", "", "hangup",
   G_CALLBACK (hangup)},
  {"hangupall", NULL, "_HangupAll                         ", "",
   "hangupall", G_CALLBACK (hangupall)},
  {"unmute", NULL, "_Unmute", "", "mute", G_CALLBACK (mute)},
  {"mute", NULL, "_mute", "", "mute", G_CALLBACK (mute)},
  {"swap", NULL, "_Swap", "", "swap", G_CALLBACK (swap)},
  {"conference", NULL, "_Conference", "", "conference",
   G_CALLBACK (conference)},
  {"addtoconference", NULL, "_Addtoconference", "", "addtoconference",
   G_CALLBACK (conference)},
  {"exitconf", NULL, "_Exit Conference", "", "exit_conference",
   G_CALLBACK (exitconf)},
  {"terminate", NULL, "_Terminate", "", "terminate",
   G_CALLBACK (terminate)},
  {"whold", NULL, "_WHold", "", "whold", G_CALLBACK (whold)},
  {"wunhold", NULL, "_WUnHold", "", "wunhold", G_CALLBACK (wunhold)},
  {"PopupLeft", NULL, "_Popup", "", "Popup", NULL},
};

/**
 *@brief
 *this function ,which updtate the menu accoding to some information,will be called when
 *ueser press the softkey.
 *@param  
 */
static void
update_menu (void)
{
  GtkAction *action;
  GList *actionGroup;
  GList *actions;

  actionGroup = gtk_ui_manager_get_action_groups (self.ui_manager);
  actions =
    gtk_action_group_list_actions (GTK_ACTION_GROUP (actionGroup->data));
  guint i = 0, length;

  length = g_list_length (actions);
  while (i < length)
  {
    g_object_set (GTK_ACTION (actions->data), "visible", FALSE, NULL);
    actions = actions->next;
    i++;
  }
  if (haswifi_flag)
  {
    switch (BUSYLINECOUNT)
    {
      case 0:
        break;
      case 1:
        action =
          gtk_ui_manager_get_action (self.ui_manager,
                                     "/ui/PopupLeft/terminate");
        g_object_set (action, "visible", TRUE, NULL);
        if (g_array_index (call_array, call_desc, displaycallnum).state == HOLD)
          action =
            gtk_ui_manager_get_action (self.ui_manager,
                                       "/ui/PopupLeft/wunhold");
        else
          action =
            gtk_ui_manager_get_action (self.ui_manager, "/ui/PopupLeft/whold");
        g_object_set (action, "visible", TRUE, NULL);
        break;
      case 2:
        action =
          gtk_ui_manager_get_action (self.ui_manager, "/ui/PopupLeft/swap");
        g_object_set (action, "visible", TRUE, NULL);
        if (g_array_index (call_array, call_desc, displaycallnum).cid == 60001)
        {
          action =
            gtk_ui_manager_get_action (self.ui_manager,
                                       "/ui/PopupLeft/terminate");
          g_object_set (action, "visible", TRUE, NULL);
        }
        else
        {
          if (g_array_index (call_array, call_desc, displaycallnum).state ==
              ACTIVE)
          {
            action =
              gtk_ui_manager_get_action (self.ui_manager,
                                         "/ui/PopupLeft/hangup");
            g_object_set (action, "visible", TRUE, NULL);
          }
        }
        break;
      default:
        break;
    }
    return;
  }

  switch (BUSYLINECOUNT)
  {
    case 0:
      break;
    case 1:
      action =
        gtk_ui_manager_get_action (self.ui_manager, "/ui/PopupLeft/newcall");
      g_object_set (action, "visible", TRUE, NULL);
      if (!HASCONFERENCE)
      {
        action =
          gtk_ui_manager_get_action (self.ui_manager, "/ui/PopupLeft/hangup");
        g_object_set (action, "visible", TRUE, NULL);
      }
      else
      {
        action =
          gtk_ui_manager_get_action (self.ui_manager,
                                     "/ui/PopupLeft/hangupall");
        g_object_set (action, "visible", TRUE, NULL);
      }


      if (g_array_index (call_array, call_desc, displaycallnum).state ==
          ACTIVE
          || (g_array_index (call_array, call_desc, displaycallnum).state ==
              CONFERENCE && !isconf_hold))
      {
        action =
          gtk_ui_manager_get_action (self.ui_manager, "/ui/PopupLeft/hold");
        g_object_set (action, "visible", TRUE, NULL);
      }
      else
      {
        action =
          gtk_ui_manager_get_action (self.ui_manager, "/ui/PopupLeft/active");
        g_object_set (action, "visible", TRUE, NULL);
      }

      if (HASCONFERENCE)
        g_object_set (gtk_ui_manager_get_action
                      (self.ui_manager, "/ui/PopupLeft/exit_conference"),
                      "visible", TRUE, NULL);
      break;

    case 2:
      action =
        gtk_ui_manager_get_action (self.ui_manager, "/ui/PopupLeft/swap");
      g_object_set (action, "visible", TRUE, NULL);

      action =
        gtk_ui_manager_get_action (self.ui_manager, "/ui/PopupLeft/hangupall");
      g_object_set (action, "visible", TRUE, NULL);

      action =
        gtk_ui_manager_get_action (self.ui_manager, "/ui/PopupLeft/hangup");
      g_object_set (action, "visible", TRUE, NULL);



      if (HASCONFERENCE
          && g_array_index (call_array, call_desc,
                            displaycallnum).state != CONFERENCE)
      {
        g_object_set (gtk_ui_manager_get_action
                      (self.ui_manager, "/ui/PopupLeft/addtoconference"),
                      "visible", TRUE, NULL);
      }
      else if (!HASCONFERENCE)
        g_object_set (gtk_ui_manager_get_action
                      (self.ui_manager, "/ui/PopupLeft/conference"),
                      "visible", TRUE, NULL);


      break;
    default:
      action =
        gtk_ui_manager_get_action (self.ui_manager, "/ui/PopupLeft/hangupall");
      g_object_set (action, "visible", TRUE, NULL);

      action =
        gtk_ui_manager_get_action (self.ui_manager, "/ui/PopupLeft/hangup");
      g_object_set (action, "visible", TRUE, NULL);
      break;
  }



  if (!ismute)
  {
    action = gtk_ui_manager_get_action (self.ui_manager, "/ui/PopupLeft/mute");
    g_object_set (action, "visible", TRUE, NULL);
  }
  else
  {
    action =
      gtk_ui_manager_get_action (self.ui_manager, "/ui/PopupLeft/unmute");
    g_object_set (action, "visible", TRUE, NULL);
  }

}


static void
init_menu (void)
{
  GError *err = NULL;

  self.action_group = gtk_action_group_new ("AllActions");
  self.ui_manager = gtk_ui_manager_new ();

  gtk_action_group_add_actions (self.action_group, action_entries,
                                G_N_ELEMENTS (action_entries), NULL);
  gtk_ui_manager_insert_action_group (self.ui_manager, self.action_group, 0);
  if (!gtk_ui_manager_add_ui_from_string
      (self.ui_manager, ui_description, -1, &err))
  {
    g_printerr ("Failed to parse menu data: %s\n", err->message);
    g_error_free (err);
    return;
  }
  self.menu_left = gtk_ui_manager_get_widget (self.ui_manager, "/PopupLeft");
  self.menu_right = NULL;
  g_signal_connect (self.menu_left, "key-press-event",
                    G_CALLBACK (popup_menu_key_press_handler), NULL);
//   g_signal_connect (G_OBJECT (self.menu_left), "key_press_event", G_CALLBACK(window_key_press_event_menu), self.currenrightlabel);
  gpe_skwindow_set_softkey_menu (GPE_SKWINDOW (self.window), SK_LEFT,
                                 self.menu_left);
  gpe_skwindow_set_softkey_menu (GPE_SKWINDOW (self.window), SK_RIGHT,
                                 self.menu_right);
}

/**
 *@brief
 *when the call_array changed,call this function to update call list.if there is only one
 *call ,the list will hide automatically.
 *
 */
void
update_list ()
{
  gchar *line;
  gchar *msg;
  gchar *state = "";
  int i = 0, j = 0;

  if (call_array->len == 1)
  {
    gtk_widget_hide_all (self.list);
    return;
  }


  gtk_clist_clear (self.list);
  gint temp_display = displaycallnum;

  for (; i < call_array->len; i++)
  {
    line = g_strdup_printf ("Call%d", i + 1);

    switch (g_array_index (call_array, call_desc, i).state)
    {
      case FREE:
        continue;
      case INCOMING:
        continue;
      case CALLING:
        state = "Calling";
        break;
      case ACTIVE:
        state = "Active";
        break;
      case HOLD:
        state = "Hold";
        break;
      case CONFERENCE:
        if (isconf_hold)
          state = "Conf(H)";
        else
          state = "Confer.";
        break;
    }
    if (!strcmp (g_array_index (call_array, call_desc, i).name, "Unknown"))
      msg = g_array_index (call_array, call_desc, i).num;
    else
      msg = g_array_index (call_array, call_desc, i).name;
    GString *temp = g_string_new (msg);

    if (temp->len > 10)
    {
      temp = g_string_truncate (temp, 7);
      g_string_append (temp, "...");
    }

    gchar *text[3] = { line, msg, state };
    j = gtk_clist_append (GTK_CLIST (self.list), text);
    gtk_clist_set_cell_style (GTK_CLIST (self.list), j, 2, style1);

    g_free (line);

  }

  displaycallnum = temp_display;
  gtk_clist_select_row (GTK_CLIST (self.list), displaycallnum, 0);
  if (j < 1)
    gtk_widget_hide_all (self.list);
  else
    gtk_widget_show_all (self.list);
}
static GtkWidget *
create_list ()
{
  GtkWidget *list;
  PangoFontDescription *font_desc;

  list = gtk_clist_new (3);
  gtk_clist_set_column_width (GTK_CLIST (list), 0, 60);

  gtk_clist_set_column_justification (GTK_CLIST (list), 2, GTK_JUSTIFY_RIGHT);

  gtk_clist_set_column_width (GTK_CLIST (list), 1, 80);
  gtk_clist_set_column_auto_resize (GTK_CLIST (list), 2, TRUE);
  gtk_clist_set_shadow_type (GTK_CLIST (list), GTK_SHADOW_NONE);
  gtk_clist_set_selection_mode (GTK_CLIST (list), GTK_SELECTION_BROWSE);
  font_desc = pango_font_description_from_string ("Sans Bold 13");
  gtk_widget_modify_font (list, font_desc);
  pango_font_description_free (font_desc);
  gtk_widget_modify_bg (list, GTK_STATE_SELECTED, &list_bg);
  gtk_widget_modify_fg (list, GTK_STATE_SELECTED, &black);
  style1 = gtk_style_copy (GTK_WIDGET (list)->style);
  style1->bg[GTK_STATE_SELECTED] = list_bg;
  style1->fg[GTK_STATE_NORMAL] = col2;
  style1->fg[GTK_STATE_SELECTED] = col2;
  pango_font_description_free (style1->font_desc);
  style1->font_desc = pango_font_description_from_string ("Sans Bold 13");
  g_signal_connect (GTK_CLIST (list), "select-row",
                    G_CALLBACK (select_changed), NULL);
  return list;
}
static void
softkey_activated (GpeSKWindow *window, gint nr)
{
  if (nr == 0)
  {
    update_menu ();
    skwindow_dbus_set_softkey_label (0, "OK");
    skwindow_dbus_set_softkey_label (1, "Cancel");

  }
  else
  {
    isspeaker = !isspeaker;
    if (isspeaker)
    {
      gpe_skwindow_set_softkey_label (GPE_SKWINDOW (self.window), SK_RIGHT,
                                      _("handset"));
      volume_image_loudspeaker (TRUE);
    }
    else
    {
      gpe_skwindow_set_softkey_label (GPE_SKWINDOW (self.window), SK_RIGHT,
                                      _("speaker"));
      volume_image_loudspeaker (FALSE);
    }
  }
}
static gboolean
setup_softkeys (void)
{
  self.num_softkeys =
    gpe_skwindow_get_softkey_count (GPE_SKWINDOW (self.window));
  if (self.num_softkeys == 2)
  {
    gpe_skwindow_set_softkey_label (GPE_SKWINDOW (self.window), SK_LEFT,
                                    _("option"));
    if (isspeaker)
      gpe_skwindow_set_softkey_label (GPE_SKWINDOW (self.window), SK_RIGHT,
                                      _("handset"));
    else
      gpe_skwindow_set_softkey_label (GPE_SKWINDOW (self.window), SK_RIGHT,
                                      _("speaker"));
    return TRUE;
  }
  return FALSE;
}

static gboolean
window_key_press_event (GtkWidget *widget, GdkEventKey *k, gpointer data)
{
  g_print ("%u\n", k->keyval);

  if ((k->keyval <= GDK_9 && k->keyval >= GDK_0) || k->keyval == 97
      || k->keyval == 100)
  {
    g_print ("%u\n", k->keyval);
    if (k->keyval == 97)
      dial_in_active ("*");
    else if (k->keyval == 100)
      dial_in_active ("#");
    else
      dial_in_active (k->string);
    return TRUE;
  }
  switch (k->keyval)
  {

    case GDK_Down:
      if (displaycallnum < call_array->len - 1)
      {
        displaycallnum++;
        gtk_clist_select_row (GTK_CLIST (self.list), displaycallnum, 0);
      }
      return TRUE;
    case GDK_Up:
      if (displaycallnum > 0)
      {
        displaycallnum--;
        gtk_clist_select_row (GTK_CLIST (self.list), displaycallnum, 0);
      }
      return TRUE;
    case GDK_Left:
      volume_changer (FALSE);
      return TRUE;
    case GDK_Right:
      volume_changer (TRUE);
      return TRUE;
    case KEY_SEND:
      if (BUSYLINECOUNT < 2)
        newcall ();
      return TRUE;
    case KEY_END:
      g_print ("\t\t call state===%d,%d\n\n\n", HASCONFERENCE, BUSYLINECOUNT);
      if (HASCONFERENCE && BUSYLINECOUNT == 1)
        hangupall ();
      else
        hangup ();
      return TRUE;
    case KEY_OK:
      break;
    default:
      break;
  }
  return FALSE;
}

void
update_time ()
{
  gchar *temp =
    formattime (g_array_index (call_array, call_desc, displaycallnum).time);
  gtk_label_set_text (GTK_LABEL (self.time_label), temp);
  g_free (temp);
}

void
update_display ()
{
  if (displaycallnum < 0)
    return;
  if (call_array->len > 1)
  {
    gtk_widget_set_size_request (self.state_image, -1, 80);
  }
  else
  {
    gtk_widget_set_size_request (self.state_image, -1, 100);
  }

  if (g_array_index (call_array, call_desc, displaycallnum).cid > 60000)
  {
    if (g_array_index (call_array, call_desc, displaycallnum).state == ACTIVE)
      gtk_image_set_from_pixbuf (GTK_IMAGE (self.state_image),
                                 self.s_image_buf[I_WIFI]);
    else
      gtk_image_set_from_pixbuf (GTK_IMAGE (self.state_image),
                                 self.s_image_buf[I_WIFIHOLD]);
  }
  else if (g_array_index (call_array, call_desc, displaycallnum).state ==
           ACTIVE
           || (g_array_index (call_array, call_desc, displaycallnum).
               state == CONFERENCE && HASCONFERENCE && !isconf_hold))
  {
    gtk_image_set_from_pixbuf (GTK_IMAGE (self.state_image),
                               self.s_image_buf[I_ACTIVE]);
  }
  else
  {
    gtk_image_set_from_pixbuf (GTK_IMAGE (self.state_image),
                               self.s_image_buf[I_HOLD]);
  }

  if (call_array->len > 4)
  {
    gtk_widget_hide (self.state_image);
  }

  gchar *temp;

  if (strcmp
      (g_array_index (call_array, call_desc, displaycallnum).name, "Unknown"))
  {
    temp = g_array_index (call_array, call_desc, displaycallnum).name;
  }
  else
    temp = g_array_index (call_array, call_desc, displaycallnum).num;
  GString *gtemp = g_string_new (temp);

  if (gtemp->len > 11)
  {
    gtemp = g_string_truncate (gtemp, 7);
    g_string_append (gtemp, "...");
  }
  gchar *temptext;

  if (ismute)
    temptext = "(Mute)  Connected to:";
  else
    temptext = "Connected to:";
  gtk_label_set_text (GTK_LABEL (self.con_label), temptext);
  gtk_label_set_text (GTK_LABEL (self.num_label), gtemp->str);
  g_string_free (gtemp, TRUE);


  gchar *temp_time =
    formattime (g_array_index (call_array, call_desc, displaycallnum).time);
  gtk_label_set_text (GTK_LABEL (self.time_label), temp_time);
  g_free (temp_time);
  gchar *str_source, *str_display;
  gint len;

  str_source =
    g_array_index (call_array, call_desc, displaycallnum).dial_num_in_active;
  len = strlen (str_source);
  if (len > 30)
    str_display = str_source + len - 30;
  else
    str_display = str_source;
  gtk_label_set_text (GTK_LABEL (self.inputlabel), str_display);

  gtk_image_set_from_pixbuf (GTK_IMAGE (self.identity_image),
                             g_array_index (call_array, call_desc,
                                            displaycallnum).pixbuf);

  gint textwidth;

  pango_layout_get_pixel_size (gtk_label_get_layout (self.num_label),
                               &textwidth, NULL);
  gint screenwidth = gdk_screen_width ();
  gint indent = (screenwidth - (textwidth + PHOTO_SIZE_W)) / 2;

  gtk_widget_set_size_request (self.identity_image, indent + PHOTO_SIZE_W, -1);

}
static void
select_changed (GtkCList *clist, gint row, gint column,
                GdkEventButton *event, gpointer user_data)
{
  displaycallnum = row;
  update_display ();
}

GtkWidget *
get_connectedwindow ()
{
  return self.window;
}

void
show_connectedwindow ()
{
  if (get_missedwindow ())
  {                             //gtk_window_iconify(GTK_WINDOW(get_callingwindow()));
    gtk_widget_hide (get_missedwindow ());
  }
  if (self.window)
  {
    gtk_widget_show_all (GTK_WINDOW (self.window));
    gtk_window_deiconify (GTK_WINDOW (self.window));
    gtk_window_present (GTK_WINDOW (self.window));
    ismute = FALSE;
    update_list ();
    update_display ();
    if (get_inputwindow ())
      gtk_window_iconify (GTK_WINDOW (get_inputwindow ()));
    if (get_callingwindow ())
      gtk_window_iconify (GTK_WINDOW (get_callingwindow ()));
    return;
  }
  GtkWidget *mainwindow;
  GtkWidget *layoutfix, *mainbox;
  GtkWidget *volumebar;
  GtkWidget *list;
  GtkWidget *con_label, *num_label, *time_label, *inputlabel;
  GtkWidget *identity_image;
  GtkWidget *image_active, *image_hold;
  PangoFontDescription *font_desc;

  conference_flag = 0;


  mainwindow = gpe_skwindow_new ();
  self.window = mainwindow;
  gtk_window_set_default_size (GTK_WINDOW (mainwindow), 300, 400);
  g_signal_connect (G_OBJECT (mainwindow), "key_press_event",
                    G_CALLBACK (window_key_press_event), NULL);
  gtk_window_set_title (GTK_WINDOW (mainwindow), "Connected window ");
  gtk_widget_modify_bg (mainwindow, GTK_STATE_NORMAL, &white);
  g_signal_connect (G_OBJECT (mainwindow), "softkey_activated",
                    G_CALLBACK (softkey_activated), NULL);
  g_signal_connect (mainwindow, "destroy",
                    G_CALLBACK (gtk_widget_destroyed), &self.window);


  layoutfix = gtk_fixed_new ();
  self.layoutfix = layoutfix;


  mainbox = gtk_vbox_new (FALSE, 0);


  if (getvolumebar ())
    volumebar = getvolumebar ();
  else
    volumebar = create_volumebar_iner ();


  list = create_list ();
  self.list = list;


  con_label = gtk_label_new ("message of line");
  num_label = gtk_label_new ("message of line");
  time_label = gtk_label_new ("message of line");
  inputlabel = gtk_label_new ("message of line");
  self.con_label = con_label;
  self.num_label = num_label;
  self.time_label = time_label;
  self.inputlabel = inputlabel;
  font_desc = pango_font_description_from_string ("Sans Bold 10");
  gtk_widget_modify_font (con_label, font_desc);
  gtk_widget_modify_font (time_label, font_desc);
  pango_font_description_free (font_desc);
  font_desc = pango_font_description_from_string ("Sans Bold 18");
  gtk_widget_modify_font (num_label, font_desc);
  pango_font_description_free (font_desc);
  font_desc = pango_font_description_from_string ("Sans Bold 15");
  gtk_widget_modify_font (inputlabel, font_desc);
  pango_font_description_free (font_desc);
  gtk_label_set_justify (GTK_LABEL (con_label), GTK_JUSTIFY_CENTER);
  gtk_label_set_justify (GTK_LABEL (num_label), GTK_JUSTIFY_CENTER);
  gtk_label_set_justify (GTK_LABEL (time_label), GTK_JUSTIFY_CENTER);
  gtk_label_set_justify (GTK_LABEL (inputlabel), GTK_JUSTIFY_RIGHT);
  gtk_misc_set_alignment (GTK_MISC (con_label), 0.5, 0.5);
  gtk_misc_set_alignment (GTK_MISC (num_label), 0.9, 0.5);
  gtk_misc_set_alignment (GTK_MISC (time_label), 0.5, 0.5);
  gtk_misc_set_alignment (GTK_MISC (inputlabel), 1, 1);
  gtk_label_set_line_wrap (GTK_LABEL (inputlabel), TRUE);


  identity_image = gtk_image_new ();
  self.identity_image = identity_image;
  gtk_misc_set_alignment (GTK_MISC (identity_image), 0, 0.5);

  gchar dir[100];

  strcat (strcpy (dir, IMAGE_DIR), "/connected.png");
  self.s_image_buf[I_ACTIVE] = gdk_pixbuf_new_from_file (dir, NULL);
  self.s_image_buf[I_CONFERENCE] = self.s_image_buf[I_ACTIVE];
  strcat (strcpy (dir, IMAGE_DIR), "/hold.png");
  self.s_image_buf[I_HOLD] = gdk_pixbuf_new_from_file (dir, NULL);
  strcat (strcpy (dir, IMAGE_DIR), "/wifi_connected.png");
  self.s_image_buf[I_WIFI] = gdk_pixbuf_new_from_file (dir, NULL);
  strcat (strcpy (dir, IMAGE_DIR), "/wifi_onhold.png");
  self.s_image_buf[I_WIFIHOLD] = gdk_pixbuf_new_from_file (dir, NULL);

  self.state_image = gtk_image_new ();


  gtk_widget_set_size_request (self.state_image, 200, 120);
  gtk_misc_set_alignment (GTK_MISC (self.state_image), 0.5, 1);


  GtkWidget *hbox = gtk_hbox_new (FALSE, 0);


  gtk_box_pack_start (GTK_BOX (mainbox), volumebar, FALSE, FALSE, 0);
  gtk_box_pack_start (GTK_BOX (mainbox), list, FALSE, FALSE, 0);
  gtk_box_pack_start (GTK_BOX (mainbox), self.state_image, FALSE, FALSE, 0);
  gtk_box_pack_start (GTK_BOX (mainbox), con_label, TRUE, TRUE, 0);

  gtk_box_pack_start (GTK_BOX (mainbox), hbox, TRUE, TRUE, 0);
  gtk_box_pack_start (GTK_BOX (hbox), num_label, TRUE, TRUE, 0);
  gtk_box_pack_start (GTK_BOX (hbox), identity_image, FALSE, FALSE, 0);

  gtk_box_pack_start (GTK_BOX (mainbox), time_label, TRUE, TRUE, 0);
  gtk_box_pack_start (GTK_BOX (mainbox), inputlabel, TRUE, TRUE, 0);

  gtk_container_add (GTK_CONTAINER (mainwindow), mainbox);

  self.have_softkeys = setup_softkeys ();

  init_menu ();

  gtk_widget_show (mainwindow);
  gtk_widget_show (mainbox);
  gtk_widget_show_all (volumebar);
  gtk_widget_show (self.state_image);
  gtk_widget_show (layoutfix);
  gtk_widget_show (con_label);
  gtk_widget_show (num_label);
  gtk_widget_show (time_label);
  gtk_widget_show (inputlabel);
  gtk_widget_show (hbox);
  gtk_widget_show (identity_image);

  update_list ();
  update_display ();

  if (get_inputwindow ())
    gtk_window_iconify (GTK_WINDOW (get_inputwindow ()));
  //gtk_widget_hide_all(get_inputwindow());
  if (get_callingwindow ())
    gtk_window_iconify (GTK_WINDOW (get_callingwindow ()));

}

/* 
vi:ts=2:nowrap:ai:expandtab
*/

