/* 	appVOC - Application of voice call service
 *
 *	Authors: JIANG Dan <dan.jiang@orange-ftgroup.com> 
 *	
 *	This software and associated documentation files (the "Software") 
 *	are copyright (C) 2005 LiPS Linux Phone Standards Forum [FranceTelecom] 
 *	All Rights Reserved. 
 *
 *	A copyright license is hereby granted for redistribution and use of 
 *	the Software in source and binary forms, with or without modification, 
 *	provided that the following conditions are met: 
 *	- Redistributions of source code must retain the above copyright notice, 
 *	this copyright license and the following disclaimer. 
 *- Redistributions in binary form must reproduce the above copyright 
 *	notice, this copyright license and the following disclaimer in the 
 *	documentation and/or other materials provided with the distribution. 
 *	- Neither the name of LiPS  nor the names of its Members may be used 
 *	to endorse or promote products derived from the Software without 
 *	specific prior written permission. 
 *
 *	A patent license for any Necessary Claims owned by Members of LiPS Forum 
 *	to make, have made, use, import, offer to sell, lease and sell or otherwise 
 *	distribute any implementation compliant with the any specification adopted 
 *	by the LiPS Forumcan be obtained from the respective Members on reasonable 
 *	and non-discriminatory terms and conditions and under reciprocity, as 
 *	regulated in more detail in the Internal Policy of the LiPS Forum. 
 *
 *	THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER, ITS MEMBERS AND CONTRIBUTORS 
 *	"AS IS", AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, 
 *	THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE 
 *	AND NON-INFRINGEMENT ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER, 
 *	ITS MEMBERS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
 *	SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, 
 *	PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; 
 *	OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, 
 *	WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) 
 *	ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE 
 *	POSSIBILITY OF SUCH DAMAGE. 
 */


#include "linestate.h"
#include "connectedwindow.h"
#include "volumebar.h"

#include <voc.h>
#include <sys/soundcard.h>
#include <fcntl.h>
#include <iac.h>
#include "iac-app-share.h"

#ifdef TEST
static gint volume = 50;
#endif

static gint times = 0;

static struct
{
  GtkWidget *window;
  gchar *call_name;
  gchar *call_num;
  guint cid;
  //gint lid;
  GtkWidget *identity_image;
  gboolean have_softkeys;
  gint num_softkeys;
  GtkActionGroup *action_group;
  GtkUIManager *ui_manager;
  GtkWidget *menu_left;
  GtkWidget *menu_right;
} self;
gboolean killalarm = FALSE;
gboolean firstrun = TRUE;
static void reject (void);
static void answer (void);
static void replace (void);
static void replace_hold (void);
static void replace_active (void);
static void ignor (void);
static void ring_stop ();
static void wifi_answer (void);

static const gchar *ui_description = " \
    <ui>\
    <popup  action=\"PopupLeft\">\
    <menuitem name=\"wifi_answer\" action=\"wifi_answer\"/>\
      <menuitem name=\"answer\" action=\"answer\"/>\
      <menuitem name=\"replace\" action=\"replace\"/>\
      <menuitem name=\"replace_hold\" action=\"replace_hold\"/>\
      <menuitem name=\"replace_active\" action=\"replace_active\"/>\
      <menuitem name=\"ignor\" action=\"ignor\"/>\
    </popup>\
    </ui>\
    ";
static const GtkActionEntry action_entries[] = {
  {"answer", NULL, "_answer", "", "answer", G_CALLBACK (answer)},
  {"wifi_answer", NULL, "_wifi_answer", "", "wifi_answer",
   G_CALLBACK (wifi_answer)},
  {"replace", NULL, "_Replace", "", "replace", G_CALLBACK (replace)},
  {"replace_hold", NULL, "_Replace hold        ", "", "replace_hold",
   G_CALLBACK (replace_hold)},
  {"replace_active", NULL, "_Replace active", "", "replace_active",
   G_CALLBACK (replace_active)},
  {"ignor", NULL, "_Ignor                   ", "", "ignor",
   G_CALLBACK (ignor)},
  {"PopupLeft", NULL, "_Popup", "", "Popup", NULL},
  {"PopupRight", NULL, "_Popup", "", "Popup", NULL},
};
void
icmc_destroy_window ()
{
  gtk_widget_destroy (self.window);
  g_print ("\ndestroy icmc window!!!!!!!!!==============\t\t%s\n",
           self.call_num);
  if (!iswifi_flag)             //jd
    ring_stop ();
  killalarm = TRUE;
}
static void
wifi_answer (void)
{
//  voc_wifi_accept (1, 60001);
  voc_accept (1, 60001);
  g_print
    ("\n\n\n\n**********************in %s, cid is: %d\n***********************\n\n\n\n",
     __FUNCTION__, self.cid);
  voc_call_evt_register (1, self.cid, VOC_EVT_CALL_STATUS, NULL, voc_cb_accept, NULL);  //cb1 is used to change the UI, etc.


}
static void
answer (void)
{
  g_print
    ("\n\n\n\n555555555555555555*in %s, cid is: %d\n***********************\n\n\n\n",
     __FUNCTION__, self.cid);


  if (ACTIVECALLINDEX != -1)
  {
    if (g_array_index (call_array, call_desc, ACTIVECALLINDEX).cid == 60001)
    {
//      voc_wifi_onhold (1, 60001);
      voc_onhold (1, 60001);
      voc_call_evt_register (1, 60001, VOC_EVT_CALL_STATUS, NULL, voc_cb_onhold, NULL); //cb1 is used to change the UI, etc.
//      if (!voc_gsm_accept (0, self.cid))
      if (!voc_accept (0, self.cid))
      {
        //voc_call_evt_register (0, self.cid, VOC_EVT_CALL_STATUS, NULL, voc_cb_accept, NULL);//cb1 is used to change the UI, etc.
      }                         //end of voc_gsm_accept
    }                           //end of if activ=-1
    else
    {

//      if (!voc_gsm_onhold
      if (!voc_onhold
          (0, g_array_index (call_array, call_desc, ACTIVECALLINDEX).cid))
      {
        voc_call_evt_register (0, g_array_index (call_array, call_desc, ACTIVECALLINDEX).cid, VOC_EVT_CALL_STATUS, NULL, voc_cb_onhold, NULL);  //cb1 is used to change the UI, etc.
      }
    }                           //end of else 60001
  }                             //end of activ
  else
  {

//    if (!voc_gsm_accept (0, self.cid))
    if (!voc_accept (0, self.cid))		
    {
      voc_call_evt_register (0, self.cid, VOC_EVT_CALL_STATUS, NULL, voc_cb_accept, NULL);      //cb1 is used to change the UI, etc.
    }
  }
}

static void
replace_hold (void)
{
  guint rcid, i;

  g_print ("####\n\n\nEnter the replace_hold\n");
  if (ACTIVECALLINDEX == -1 || BUSYLINECOUNT != 2)
  {
    g_print ("%d,%d\n", ACTIVECALLINDEX, BUSYLINECOUNT);
    g_assert_not_reached ();
  }
  else
  {
    for (i = 0; i < call_array->len; i++)
    {
      if (g_array_index (call_array, call_desc, i).state == HOLD)
      {
        rcid = g_array_index (call_array, call_desc, i).cid;
        g_print ("The held call_id is equal to %d\n", rcid);
//        if (!voc_gsm_replace_hold (0, rcid))
        if (!voc_replace_hold (0, rcid))			
        {
          voc_call_evt_register (0, rcid, VOC_EVT_CALL_STATUS, NULL, voc_cb_replace_hold, NULL);        //cb1 is used to change the UI, etc.
        }
        return;
      }
    }
    g_assert_not_reached ();
  }
}


static void
replace_active (void)
{

  guint rcid;

  if (ACTIVECALLINDEX == -1 || BUSYLINECOUNT != 2)
  {
    g_print ("%d,%d", ACTIVECALLINDEX, BUSYLINECOUNT);
    g_assert_not_reached ();
  }
  else
  {
    rcid = g_array_index (call_array, call_desc, ACTIVECALLINDEX).cid;
 //   if (!voc_gsm_hungup_active (0, rcid))
    if (!voc_hungup_active (0, rcid))
    {
      voc_call_evt_register (0, rcid, VOC_EVT_CALL_STATUS, NULL, voc_cb_hungup_active, NULL);   //cb1 is used to change the UI, etc.
    }
  }
}


static void
replace (void)
{
  guint rcid;

  g_assert (ACTIVECALLINDEX != -1);
  if (ACTIVECALLINDEX != -1)
  {
    rcid = g_array_index (call_array, call_desc, ACTIVECALLINDEX).cid;
//    if (!voc_gsm_hungup_active (0, rcid))
    if (!voc_hungup_active (0, rcid))
    {
      voc_call_evt_register (0, rcid, VOC_EVT_CALL_STATUS, NULL, voc_cb_hungup_active, NULL);   //cb1 is used to change the UI, etc.
    }

  }
}
static void
ignor (void)
{
}

static void
reject (void)
{
//  if (!voc_gsm_hungup_held (0, self.cid))
  if (!voc_hungup_held (0, self.cid))
  {
    voc_call_evt_register (0, self.cid, VOC_EVT_CALL_STATUS, NULL,
                           voc_cb_hungup_held, NULL);
  }
}

/* init menus according to the linestate;
 *will be called when press the Leftsoftkey everytime;
 */
static void
update_menu (void)
{
  GtkAction *action;
  GList *actionGroup;
  GList *actions;

  actionGroup = gtk_ui_manager_get_action_groups (self.ui_manager);
  actions =
    gtk_action_group_list_actions (GTK_ACTION_GROUP (actionGroup->data));
  guint i = 0, length;

  length = g_list_length (actions);
  while (i < length)
  {
    g_object_set (GTK_ACTION (actions->data), "visible", FALSE, NULL);
    actions = actions->next;
    i++;
  }

  if (iswifi_flag)
  {
    action =
      gtk_ui_manager_get_action (self.ui_manager, "/ui/PopupLeft/wifi_answer");
    g_object_set (action, "visible", TRUE, NULL);
    return;
  }

  switch (BUSYLINECOUNT)
  {
    case 0:
      action =
        gtk_ui_manager_get_action (self.ui_manager, "/ui/PopupLeft/answer");
      g_object_set (action, "visible", TRUE, NULL);
      break;
    case 1:
      action =
        gtk_ui_manager_get_action (self.ui_manager, "/ui/PopupLeft/answer");
      g_object_set (action, "visible", TRUE, NULL);
      if (ACTIVECALLINDEX != -1 && !haswifi_flag)
      {
        action =
          gtk_ui_manager_get_action (self.ui_manager, "/ui/PopupLeft/replace");
        g_object_set (action, "visible", TRUE, NULL);
      }
      break;
    case 2:
      if (HASCONFERENCE == 1 && isconf_hold == 1)
      {
      }
      else
      {
        action =
          gtk_ui_manager_get_action (self.ui_manager,
                                     "/ui/PopupLeft/replace_hold");
        g_object_set (action, "visible", TRUE, NULL);
      }
      action =
        gtk_ui_manager_get_action (self.ui_manager,
                                   "/ui/PopupLeft/replace_active");
      g_object_set (action, "visible", TRUE, NULL);
      break;
    default:
      break;
  }
}

static void
init_menu (void)
{
  GError *err = NULL;

  self.action_group = gtk_action_group_new ("AllActions");
  self.ui_manager = gtk_ui_manager_new ();

  gtk_action_group_add_actions (self.action_group, action_entries,
                                G_N_ELEMENTS (action_entries), NULL);
  gtk_ui_manager_insert_action_group (self.ui_manager, self.action_group, 0);
  if (!gtk_ui_manager_add_ui_from_string
      (self.ui_manager, ui_description, -1, &err))
  {
    g_printerr ("Failed to parse menu data: %s\n", err->message);
    g_error_free (err);
    return;
  }
  self.menu_left = gtk_ui_manager_get_widget (self.ui_manager, "/PopupLeft");
  self.menu_right = NULL;
  g_signal_connect (self.menu_left, "key-press-event",
                    G_CALLBACK (popup_menu_key_press_handler), NULL);
  gpe_skwindow_set_softkey_menu (GPE_SKWINDOW (self.window), SK_LEFT,
                                 self.menu_left);
  gpe_skwindow_set_softkey_menu (GPE_SKWINDOW (self.window), SK_RIGHT,
                                 self.menu_right);
}

static gboolean
window_key_press_event (GtkWidget *widget, GdkEventKey *k, gpointer data)
{
  if (!k->state)
  {
    switch (k->keyval)
    {
#ifdef TEST
      case KEY_ASIDE_L1:
        volume += 10;
        if (volume > 100)
          volume = 100;
        set_volume_to_mixer (volume);
        return TRUE;
      case KEY_ASIDE_L2:
        if (volume <= 11)
          volume -= 3;
        else
          volume -= 10;
        if (volume < 0)
          volume = 0;
        set_volume_to_mixer (volume);
        return TRUE;
#endif
      case KEY_SEND:
        switch (BUSYLINECOUNT)
        {
          case 0:
          case 1:
            answer ();
            break;
          case 2:
            replace_active ();
            break;
        }
        return TRUE;
      case KEY_END:
        reject ();
        return TRUE;
      default:
        break;
    }

  }
  return FALSE;
}
static void
softkey_activated (GtkWidget *window, gint nr)
{
  if (nr == 0)
  {
    skwindow_dbus_set_softkey_label (0, "OK");
    skwindow_dbus_set_softkey_label (1, "Cancel");
    update_menu ();
  }
  else
  {
    reject ();
  }
}
static gboolean
setup_softkeys (void)
{
  self.num_softkeys =
    gpe_skwindow_get_softkey_count (GPE_SKWINDOW (self.window));
  if (self.num_softkeys == 2)
  {
    gpe_skwindow_set_softkey_label (GPE_SKWINDOW (self.window), SK_LEFT,
                                    _("option"));
    gpe_skwindow_set_softkey_label (GPE_SKWINDOW (self.window), SK_RIGHT,
                                    _("reject"));
    return TRUE;
  }
  return FALSE;
}
void recplay (char *name);

static void
send_iacmessage_to_soundserver (gchar *app, gchar *con_type, gchar *value)
{
  extern iac_context_t *context;
  iac_arguments_t *args = NULL;

  args = iac_arguments_new_with_args (IAC_TYPE_STRING, app,
                                      IAC_TYPE_STRING, con_type,
                                      IAC_TYPE_STRING, value, IAC_TYPE_INVALID);

  g_print ("%s(): iac_execute()start\n", __FUNCTION__);
  iac_execute_service (context,
                       SS_IAC_SERVICE,
                       SS_IAC_OBJECT, SS_IAC_INTERFACE, "haha", args, NULL);
  g_print ("%s(): iac_execute() done\n", __FUNCTION__);
  iac_arguments_free (args);
  return;
}
static void
incoming_ring (gchar *ringtone_path)
{
  send_iacmessage_to_soundserver ("voc", "location", ringtone_path);
}
static void
ring_stop ()
{
  send_iacmessage_to_soundserver ("voc", "stop", NULL);
}

void
create_icmcdialog (guint cid, gchar *num1)
{
  g_print
    ("\n\n\n\n\n++++++++++++++++++ncreate icmc window!!!!!!!!!create%s:%d\n\n\n\n\n",
     num1, times++);
  gchar *num = g_strdup (num1);
  gchar *name;
  gchar *photo_path;
  gchar *ringtone_path;
  GtkWidget *identity_image;
  GtkWidget *mainwindow;
  GtkWidget *mainbox, *label1, *label2;
  GtkWidget *hbox;
  gint width, height;
  gint pos_x, pos_y;

  search_from_addressbook (num, &name, &photo_path, &ringtone_path);


  gchar *path_test = g_strdup_printf ("%s/1.mp3", IMAGE_DIR);

  if (!iswifi_flag)             //jd
    incoming_ring (path_test);
  g_free (ringtone_path);
  g_free (path_test);


  if (!name || strlen (name) == 0)
    name = strdup ("Unknown");
  GdkPixbuf *pbuf = NULL;

  if (photo_path)
  {
    pbuf = gdk_pixbuf_new_from_file_at_size (photo_path, 50, 50, NULL);
    g_free (photo_path);
  }
  if (!pbuf)
    pbuf = default_photo;
  identity_image = gtk_image_new_from_pixbuf (pbuf);

  self.call_num = num;
  self.call_name = name;
  self.identity_image = identity_image;
  self.cid = cid;
  addnewcall (cid, self.call_name, num, INCOMING, identity_image);
  mainwindow = gpe_skwindow_new ();
  gtk_window_set_type_hint (GTK_WINDOW (mainwindow),
                            GDK_WINDOW_TYPE_HINT_SPLASHSCREEN);

  gtk_window_set_modal (GTK_WINDOW (mainwindow), TRUE);
  gchar dir[100];

  strcpy (dir, IMAGE_DIR);
  strcat (dir, "/incoming_popup.png");

  set_background_pixmap (dir, mainwindow, &width, &height);
  self.window = mainwindow;
  gtk_window_set_default_size (GTK_WINDOW (mainwindow), width, height);

  pos_x = (gdk_screen_width () - width) / 2;
  pos_y = (gdk_screen_height () - height) *2 / 3;
  gtk_window_move (GTK_WINDOW (mainwindow), pos_x, pos_y);
  gtk_window_set_title (GTK_WINDOW (mainwindow), "Incoming Call");

  g_signal_connect (G_OBJECT (mainwindow), "key_press_event",
                    G_CALLBACK (window_key_press_event), NULL);
  g_signal_connect (G_OBJECT (mainwindow), "softkey_activated",
                    G_CALLBACK (softkey_activated), NULL);



  label1 = gtk_label_new ("");
  label2 = gtk_label_new ("");
  gtk_label_set_justify (GTK_LABEL (label1), GTK_JUSTIFY_CENTER);
  gtk_label_set_justify (GTK_LABEL (label2), GTK_JUSTIFY_CENTER);


  gchar *temp_string;

  if (strcmp (name, "Unknown"))
  {
    temp_string = name;
  }
  else
    temp_string = num;
  GString *temp = g_string_new (temp_string);

  if (temp->len > 11)
  {
    temp = g_string_truncate (temp, 7);
    g_string_append (temp, "...");
  }

  char *markup;

  markup =
    g_markup_printf_escaped
    ("<span size=\"large\"><b>Incoming call !</b></span>\n");
  gtk_label_set_markup (GTK_LABEL (label1), markup);
  g_free (markup);
  markup =
    g_markup_printf_escaped ("<span size=\"20500\"><b>%s</b></span>\n",
                             temp->str);
  gtk_label_set_markup (GTK_LABEL (label2), markup);
  g_free (markup);

  init_menu ();

  mainbox = gtk_vbox_new (FALSE, 0);

  hbox = gtk_hbox_new (FALSE, 0);
  gtk_misc_set_alignment (GTK_MISC (label1), 0.5, 0.5);
  gtk_misc_set_alignment (GTK_MISC (label2), 0.5, 0.2);
  gtk_misc_set_alignment (GTK_MISC (self.identity_image), 0, 0);
  gtk_box_pack_start (GTK_BOX (hbox), label2, TRUE, TRUE, 0);
  gtk_widget_set_size_request (self.identity_image, 60, -1);
  gtk_box_pack_start (GTK_BOX (hbox), self.identity_image, FALSE, FALSE, 0);


  gtk_box_pack_start (GTK_BOX (mainbox), label1, TRUE, TRUE, 0);
  gtk_box_pack_start (GTK_BOX (mainbox), hbox, TRUE, TRUE, 0);
  gtk_container_add (GTK_CONTAINER (mainwindow), mainbox);
  self.have_softkeys = setup_softkeys ();
  gtk_widget_show_all (mainwindow);
}

void
recplay (char *name)
{
  int timelimit = 0, dsp_speed = 22050, dsp_stereo = 0;
  static int audio, abuf_size = 0;
  int fd, l;
  char *audiobuf;
  int count, c;
  gchar *audio_name = "/dev/dsp";
  int samplesize = 16;
  int prof = APF_NORMAL;

  if (firstrun)
  {
    audio = open (audio_name, O_WRONLY, 0);
    if (audio == -1)
      exit (-1);
    ioctl (audio, SNDCTL_DSP_SAMPLESIZE, &samplesize);
    ioctl (audio, SNDCTL_DSP_PROFILE, &prof);
    if (ioctl (audio, SNDCTL_DSP_SPEED, &dsp_speed) == -1)
    {

      perror (audio_name);
      exit (-1);
    }
    ioctl (audio, SNDCTL_DSP_GETBLKSIZE, &abuf_size);
    firstrun = FALSE;
  }



  if (abuf_size < 1)
  {
    perror ("GETBLKSIZE");
    exit (-1);
  }
  if ((audiobuf = malloc (abuf_size)) == NULL)
  {
    printf ("Unable to allocate input/output buffer\n");
    exit (-1);
  }


  while (!killalarm)
  {
    if ((fd = open (name, O_RDONLY, 0)) == -1)
    {
      perror (name);
      exit (-1);
    }
    count = 0x7fffffff;
    while (count && !killalarm)
    {
      c = count;

      if (c > abuf_size)
        c = abuf_size;

      if ((l = read (fd, audiobuf, c)) > 0)
      {
        if (write (audio, audiobuf, l) != l)
        {
          perror (audio_name);
          exit (-1);
        }
        count -= l;
      }
      else
      {
        if (l == -1)
        {
          perror (name);
          exit (-1);
        }
        count = 0;              /* Stop */
      }

    }                           /* while (count) */
    if (fd != 0)
      close (fd);
  }
  g_free (audiobuf);
}

/* 
vi:ts=2:nowrap:ai:expandtab
*/

