/* 	appVOC - Application of voice call service
 *
 *	Authors: JIANG Dan <dan.jiang@orange-ftgroup.com> 
 *	
 *	This software and associated documentation files (the "Software") 
 *	are copyright (C) 2005 LiPS Linux Phone Standards Forum [FranceTelecom] 
 *	All Rights Reserved. 
 *
 *	A copyright license is hereby granted for redistribution and use of 
 *	the Software in source and binary forms, with or without modification, 
 *	provided that the following conditions are met: 
 *	- Redistributions of source code must retain the above copyright notice, 
 *	this copyright license and the following disclaimer. 
 *- Redistributions in binary form must reproduce the above copyright 
 *	notice, this copyright license and the following disclaimer in the 
 *	documentation and/or other materials provided with the distribution. 
 *	- Neither the name of LiPS  nor the names of its Members may be used 
 *	to endorse or promote products derived from the Software without 
 *	specific prior written permission. 
 *
 *	A patent license for any Necessary Claims owned by Members of LiPS Forum 
 *	to make, have made, use, import, offer to sell, lease and sell or otherwise 
 *	distribute any implementation compliant with the any specification adopted 
 *	by the LiPS Forumcan be obtained from the respective Members on reasonable 
 *	and non-discriminatory terms and conditions and under reciprocity, as 
 *	regulated in more detail in the Internal Policy of the LiPS Forum. 
 *
 *	THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER, ITS MEMBERS AND CONTRIBUTORS 
 *	"AS IS", AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, 
 *	THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE 
 *	AND NON-INFRINGEMENT ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER, 
 *	ITS MEMBERS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
 *	SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, 
 *	PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; 
 *	OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, 
 *	WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) 
 *	ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE 
 *	POSSIBILITY OF SUCH DAMAGE. 
 */

#ifndef	__LIPS_VOCAPP_LINESTATE_H
#define	__LIPS_VOCAPP_LINESTATE_H

#include <string.h>
#include <unistd.h>
#include <stdio.h>
#include <stddef.h>
#include <stdlib.h>
#include <gtk/gtk.h>
#include <gdk/gdkkeysyms.h>

#include <libintl.h>
#include <gpe/init.h>              /* gpe_application_init */   /* gpe_info_dialog */
#include <gpe/gpeskwindow.h>

#include "../src/callbacks.h"

#define _(x) gettext(x)
#define MAX_LINE_NUM 2
#define PHOTO_SIZE_W 40
/* Define the keyvalue on pc*/
/***************************/

/* Define the keyvalue on mobile*/
#define KEY_SEND 65474
#define KEY_END 65307
#define KEY_OK 65293
#define KEY_ASIDE_R2 110
#define KEY_ASIDE_R3 98
#define KEY_ASIDE_L1 54
#define KEY_ASIDE_L2 116
/***************************/

#define HASCONFERENCE hasconference()
#define ACTIVECALLINDEX active_call_index()
#define BUSYLINECOUNT busy_line_count()

#include <vochtype.h>
#include <callhistory.h>
#include <vochcallhistory.h>

#ifdef __cplusplus
extern "C"
{
#endif
//the color of background
  GdkColor white;
/**
 *define the massage dialog type,usually used by createmsgdialog(char *,msg_type);
 */
  typedef enum
  {
    MSG_ERROR = 0,
    MSG_CONFIRM = 1,
    MSG_HANGUP = 2,             //the dialog after hangup a call
    MSG_NORMAL_TIMEOUT = 3      //a normal dialog which will disapear in a predefined time
  } msg_type;

  enum
  {
    SK_LEFT = 0,
    SK_RIGHT = 1,
    SK_MAX = 2
  };
  
  typedef enum
  {
    FREE = 0,
    CALLING = 1,
    ACTIVE = 2,
    HOLD = 3,
    INCOMING = 4,
    CONFERENCE = 5
  } State;
  gint flag_fn;

/*the path of image obtained from env when ui_init; */
  gchar *IMAGE_DIR;
  gchar *ABOOK_DATA_PATH;
  
/*indicate the index of a call in call_array ,whose information is showing on screen; */
  gint displaycallnum;

/*record whether the loudspeaker is on; */
  gboolean isspeaker;

/*indicate whether is mute; */
  gboolean ismute;

/*the background pixmap of all window,(there is only inputwindow use this pixmap in current vision) */
  GdkPixmap *bg_pixmap;

/*the default photo */
  GdkPixbuf *default_photo;

  gint conference_flag;

  gboolean isconf_hold;

  gboolean iswifi_flag;

  gboolean haswifi_flag;

  gboolean isfirst_flag;
  
/**
 *description of a call, this is the basic data struct of the call. 
 */
  typedef struct
  {
    guint cid;                  //the id of this call
    State state;                //the status of this call
    //gint lid;
    gchar *name;                //the remote peer name of this call
    gchar *num;                 //the number of remote peer
    gchar *dial_num_in_active;  //user's input after this call put-through;
    GdkPixbuf *pixbuf;          //the photo of remote peer
    glong time;                 //the last time of this call ;
    gint timer;                 //the handle of the timer;
  }
  call_desc;

/*the array of call_des,record all of current call */
  GArray *call_array;

/*globe tools : transform the State to char *; */
  gchar *statetostring (State state);

/**change the status of a calll;
 *@param linenum : the index of the call;
 *@param state : the status want to change to
 *
 */
  gint changestate (gint linenum, State state);
/**
 *init the call_array,busylinecount,bg_pixmap etc.
 *called before create ui;
 */

  gint init_ui ();
/**
 *this is the basic function to add a call_desc,this function create a new call_desc
 *then add it to call_array;
 *@param cid : call id that assigned by phone server;
 *@param name : the remote peer name
 *@param num : the telephone number
 *@param state : the initial status of this call
 *@param image : this photo of the remote peer
 *@return TRUE if successed,FLASE if any error occured
 */

  gint addnewcall (guint cid, gchar *name, gchar *num, State state,
                   GtkWidget *image);

/**
 *the callback fun when hold signal returned,use to update the ui
 *called by cb_hold() in interface.h
 *@param cid the call id;
 *
 */
  gint holdcall (guint cid);

/**
 *the callback function which will be called when user accepted a call,or user
 *active a hold call;
 *@param cid the call id;
 */

  gint activecall (guint cid);

  gint dropactivecall ();

  gint dropcall_active_cid (guint cid);


  gint dropholdcall ();

  gint dropcall_all (guint cid);


/**
 *the callback function which will be called when hungup signal returned;
 */
  gint dropcall_cid (guint cid);


  gint cb_conference (guint cid);

  gint cb_exitconf (guint cid);





/**
 *the callback function which will be called when hungup signal returned;
 */

/**
 *this is a test function that find the name and the photo thougth the num;
 *the information save in a file named addressbook.data;
 *the information formed in "num,name,photo_path";
 *
 *I will change the implement of this function when we connecting to the addressbook
 *
 *@param
 */
/* void identity(const gchar *num,gchar **name,GtkWidget **identity_image); */

/**
 *globe tool :transform time into the form of "time:  00:00:00"
 *@param time input time ;
 *@return a string formed as "time :00:00:00"
 */

  gchar *formattime (glong time);
/**
 *when user input after this call put-through,call this function to record the num
 *user has typed,show the number,and dial this number;
 *
 *@param num user typed num ,it usually be a char .
 */

  void dial_in_active (gchar *num);

/**
 *globe tool :load a image ;you can get pixbuf,pixmap,width,heigth of the image ;
 *@param filename the path of the image (full path)
 *@param pixbuf_b the pixbuf representation of the image
 *@param pixmap_b the pixmap representation of the image
 *@param width_b the width of the image
 *@param height_b the height of the image
 *@return if successed to load image return TRUE,else return FALSE;
 *
 *sometimes you do not need all of pixbuf,pixmap,width,heigth,you can pass NULL to the parameter.
 */

  gboolean invoke_addressbook_ui ();

  gboolean invoke_addressbook_ui_iac ();

  gboolean search_from_addressbook (const gchar *num, gchar **name_b,
                                    gchar **photo_path_b,
                                    gchar **Ringtone_path_b);

  gboolean load_image (const gchar *filename, GdkPixbuf **pixbuf_b,
                       GdkPixmap **pixmap_b, gint *width_b, gint *height_b);

    gboolean
    popup_menu_key_press_handler (GtkWidget *menu, GdkEventKey *k,
                                  gpointer userdata);

  gboolean hasconference ();
  gint active_call_index ();
  gint busy_line_count ();
  gboolean voc_call_history_add_history (gchar *num, voch_call_type_t type,
                                         time_t duration);


#ifdef __cplusplus
}
#endif                          /* __cplusplus */

#endif                          /* __LIPS_VOCAPP_LINESTATE_H */

/* 
vi:ts=2:nowrap:ai:expandtab
*/

