/* 	appVOC - Application of voice call service
 *
 *	Authors: JIANG Dan <dan.jiang@orange-ftgroup.com> 
 *	
 *	This software and associated documentation files (the "Software") 
 *	are copyright (C) 2005 LiPS Linux Phone Standards Forum [FranceTelecom] 
 *	All Rights Reserved. 
 *
 *	A copyright license is hereby granted for redistribution and use of 
 *	the Software in source and binary forms, with or without modification, 
 *	provided that the following conditions are met: 
 *	- Redistributions of source code must retain the above copyright notice, 
 *	this copyright license and the following disclaimer. 
 *- Redistributions in binary form must reproduce the above copyright 
 *	notice, this copyright license and the following disclaimer in the 
 *	documentation and/or other materials provided with the distribution. 
 *	- Neither the name of LiPS  nor the names of its Members may be used 
 *	to endorse or promote products derived from the Software without 
 *	specific prior written permission. 
 *
 *	A patent license for any Necessary Claims owned by Members of LiPS Forum 
 *	to make, have made, use, import, offer to sell, lease and sell or otherwise 
 *	distribute any implementation compliant with the any specification adopted 
 *	by the LiPS Forumcan be obtained from the respective Members on reasonable 
 *	and non-discriminatory terms and conditions and under reciprocity, as 
 *	regulated in more detail in the Internal Policy of the LiPS Forum. 
 *
 *	THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER, ITS MEMBERS AND CONTRIBUTORS 
 *	"AS IS", AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, 
 *	THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE 
 *	AND NON-INFRINGEMENT ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER, 
 *	ITS MEMBERS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
 *	SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, 
 *	PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; 
 *	OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, 
 *	WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) 
 *	ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE 
 *	POSSIBILITY OF SUCH DAMAGE. 
 */

#include "linestate.h"
GtkWidget *thiswindow;
GtkWidget *label;

static void
softkey_activated (GtkWidget *window, gint nr)
{
  if (nr == 0)
  {
/*     gtk_widget_destroy(window); */
  }
  else
  {
    gtk_widget_destroy (window);
    thiswindow = NULL;
  }
}

static gboolean
setup_softkeys (GtkWidget *window)
{

  if (gpe_skwindow_get_softkey_count (GPE_SKWINDOW (window)) == 2)
  {
    gpe_skwindow_set_softkey_label (GPE_SKWINDOW (window), SK_LEFT, _(""));
    gpe_skwindow_set_softkey_label (GPE_SKWINDOW (window), SK_RIGHT, _("quit"));
    return TRUE;
  }
  return FALSE;
}

static void
update (gint num)
{
  gchar *displaystr = g_strdup_printf ("%d  \n missed call", num);

  gtk_label_set_text (GTK_LABEL (label), displaystr);
  g_free (displaystr);
}

GtkWidget *
get_missedwindow ()
{
  return thiswindow;
}


void
show_misscalldialog (gint *pnum)
{

  if (thiswindow)
  {
    update (*pnum);
    gtk_widget_show_all (thiswindow);
    gtk_window_present (GTK_WINDOW (thiswindow));
    return;
  }

  *pnum = 1;
  GtkWidget *mainwindow;
  GtkWidget *mainbox;
  GtkWidget *image;
  PangoFontDescription *font_desc;
  gint width, height;



  mainwindow = gpe_skwindow_new ();
  thiswindow = mainwindow;
  gtk_window_set_type_hint (GTK_WINDOW (mainwindow),
                            GDK_WINDOW_TYPE_HINT_SPLASHSCREEN);

  gtk_window_set_modal (GTK_WINDOW (mainwindow), TRUE);

  gchar *dir;

  dir = g_strdup_printf ("%s/incoming_popup.png", IMAGE_DIR);
  set_background_pixmap (dir, mainwindow, &width, &height);
  g_free (dir);

  dir = g_strdup_printf ("%s/missed.png", IMAGE_DIR);
  image = gtk_image_new_from_file (dir);
  g_free (dir);
  gtk_widget_set_size_request (image, 65, -1);
  gtk_misc_set_alignment (GTK_MISC (image), 1, 0.5);

  gtk_window_set_title (GTK_WINDOW (mainwindow), "missed call !");
  gtk_window_set_default_size (GTK_WINDOW (mainwindow), width, height);
  gint pos_x = (gdk_screen_width () - width) / 2;
  gint pos_y = (gdk_screen_height () - height) *2 / 3;

  gtk_window_move (GTK_WINDOW (mainwindow), pos_x, pos_y);


  gchar *displaystr = g_strdup_printf ("%d \n missed call", *pnum);

  label = gtk_label_new (displaystr);
  g_free (displaystr);

  font_desc = pango_font_description_from_string ("Sans Bold 16");
  gtk_widget_modify_font (label, font_desc);
  pango_font_description_free (font_desc);

  gtk_label_set_justify (GTK_LABEL (label), GTK_JUSTIFY_CENTER);

  mainbox = gtk_hbox_new (FALSE, 0);
  gtk_box_pack_start (GTK_BOX (mainbox), image, FALSE, FALSE, 0);
  gtk_box_pack_start (GTK_BOX (mainbox), label, TRUE, TRUE, 0);
  gtk_container_add (GTK_CONTAINER (mainwindow), mainbox);
  g_signal_connect (G_OBJECT (mainwindow), "softkey_activated",
                    G_CALLBACK (softkey_activated), NULL);
  setup_softkeys (mainwindow);
  gtk_widget_show_all (mainwindow);
}

/* 
vi:ts=2:nowrap:ai:expandtab
*/

